#include "ShowTree.h"

ShowTree::ShowTree(MyTree *t, QString sysdirectory)
{
  treetab = t;
  sysDir = sysdirectory.copy();
}

bool ShowTree::updateTreePic(MyTree *t, QFrame *f, int x, int &y)
{
  int i, newy;
  QString temp1=t->GetFeature1(1)->copy();
  int pos=temp1.findRev(" ");
  int hm=temp1.length()-pos;
  temp1=temp1.right(hm-1);
  QString widclass = t->GetFeature1(2)->copy();
  if (widclass != "MyClass")
    {
      QLabel *icon = new QLabel(f);
      icon->setGeometry(x, y, 25, 25);
      icon->setBackgroundColor("white");
      if (widclass == "MyCanvas") 
	icon->setPixmap(QPixmap(sysDir+"images/canvas_i.xpm"));
      if (widclass == "MyChoice") 
	icon->setPixmap(QPixmap(sysDir+"images/choice_i.xpm"));
      if (widclass == "MyLabel") 
	icon->setPixmap(QPixmap(sysDir+"images/label_i.xpm"));
      if (widclass == "MyList") 
	icon->setPixmap(QPixmap(sysDir+"images/list_i.xpm"));
      if (widclass == "MyMenuBar") 
	icon->setPixmap(QPixmap(sysDir+"images/menu_i.xpm"));
      if (widclass == "MyMenu")	
	icon->setPixmap(QPixmap(sysDir+"images/menu_item_i.xpm"));
      if (widclass == "MyPushButton") 
	icon->setPixmap(QPixmap(sysDir+"images/button_i.xpm"));
      if (widclass == "MyRadioButton") 
	icon->setPixmap(QPixmap(sysDir+"images/checkbox_i.xpm"));
      if (widclass == "MyScrollBar") 
	icon->setPixmap(QPixmap(sysDir+"images/scroll_i.xpm"));
      if (widclass == "MyTextArea") 
	icon->setPixmap(QPixmap(sysDir+"images/text_area_i.xpm"));
      if (widclass == "MyTextField") 
	icon->setPixmap(QPixmap(sysDir+"images/text_i.xpm"));
      if (widclass == "ChoiceItem") 
	{
	  icon->setPixmap(QPixmap(sysDir+"images/choice_i.xpm"));
	  temp1 = t->GetFeature1(3)->copy();
	}
      if (widclass == "ListItem") 
	{
	  icon->setPixmap(QPixmap(sysDir+"images/list_i.xpm"));
	  temp1 = t->GetFeature1(3)->copy();
	}
      if (widclass == "subMenu")  
	{
	  icon->setPixmap(QPixmap(sysDir+"images/menusub_i.xpm"));
	  temp1 = t->GetFeature1(3)->copy();
	}
      if (widclass == "MenuItem")
	{
	  if (t->GetFeature1(3)->isEmpty() == TRUE)
	    {
	      icon->setPixmap(QPixmap(sysDir+"images/menusep_i.xpm"));
	      temp1 = "----";
	    }
	  else
	    if (t->GetFeature2(22) == 1)
	      {
		icon->setPixmap(QPixmap(sysDir+"images/menuch_i.xpm"));
		temp1 = t->GetFeature1(3)->copy();
	      }
	    else
	      {
		icon->setPixmap(QPixmap(sysDir+"images/menu_i.xpm"));
		temp1 = t->GetFeature1(3)->copy();
	      }
	}
      x += 25;
    }
  QLabel *l;
  int j, numch, oldy;

  numch = t->GetNumChildren();
  if (numch)
    {
      l = new MyLabel("mylabel", f);
      connect(l, SIGNAL(press(QWidget*, QMouseEvent*)), SLOT(oneClick(QWidget*)));
    }
  else 
    l = new QLabel(f);
  l->setGeometry(x, y, temp1.length() * 6, 25);
  l->setBackgroundColor("white");
  x += temp1.length() * 6;
  l->setText(temp1);
  l->setAlignment(AlignCenter);
  if (t->GetFeature2(14) == 0) return TRUE;
  if (numch) 
    {
      QLabel *l1 = new QLabel(f);
      l1->setPixmap(QPixmap(sysDir+"images/i3.xpm")); // "-|"
      l1->setGeometry(x, y, 25, 25);
      for (i = 0; i < numch; i++)
	{
	  y += 25;
	  if (i == numch-1) 
	    {
	      if (t->GetChildren(i)->GetNumChildren() != 0)
		{
		  QLabel *icon1 = new QLabel(f);
		  icon1->setGeometry(x, y, 25, 25);
		  if (t->GetChildren(i)->GetFeature2(14) != 0) 
		    icon1->setPixmap(QPixmap(sysDir+"images/i8.xpm"));
		  else
		    icon1->setPixmap(QPixmap(sysDir+"images/i6.xpm"));
		}
	      else
		{
		  QLabel *l2 = new QLabel(f); // "\-"
		  l2->setPixmap(QPixmap(sysDir+"images/i4.xpm"));
		  l2->setGeometry(x, y, 25, 25);
		}
	    }
	  else
	    {
	      if (t->GetChildren(i)->GetNumChildren() != 0)
		{
		  QLabel *icon1 = new QLabel(f);
		  icon1->setGeometry(x, y, 25, 25);
		  if (t->GetChildren(i)->GetFeature2(14) != 0) 
		    icon1->setPixmap(QPixmap(sysDir+"images/i7.xpm"));
		  else
		    icon1->setPixmap(QPixmap(sysDir+"images/i5.xpm"));
		}
	      else
		{
		  QLabel *l2 = new QLabel(f); // "|-"
		  l2->setPixmap(QPixmap(sysDir+"images/i2.xpm"));
		  l2->setGeometry(x, y, 25, 25);
		}
	    }
	  x += 25;
	  oldy = y+25;
	  updateTreePic(t->GetChildren(i), f, x, y);
	  x -= 25;
	  if (i < numch-1)
	    {
	      if (oldy <= y)
		{
		  for (j = oldy; j <= y; j += 25)
		    {
		      QLabel *l3 = new QLabel(f);
		      l3->setPixmap(QPixmap(sysDir+"images/i1.xpm")); // "|"
		      l3->setGeometry(x, j, 25, 25); 
		    }
		}
	    }
	}
      y += 25;
    }
  return TRUE;
}

void ShowTree::displayTree(bool first)
{ 
  int ty;
  ty = 5;
  mainframe = new QFrame(NULL, "main_frame");
  if (first != TRUE) 
    mainframe->setGeometry(wx, wy, 520, 450);
  mainframe->setMinimumSize(QSize(520,450));
  mainframe->setMaximumSize(QSize(520,450));
  lastx = 1000;
  lasty = 1000;
  QString temp1;
  temp1 = *treetab->GetFeature1(1);
  int pos=temp1.findRev(" ");
  int hm=temp1.length()-pos;
  temp1=temp1.right(hm-1);
  temp1 += " - Class Tree";
  mainframe->setCaption(temp1);
  frame = new QFrame(mainframe, "frame");
  frame->setGeometry(20,30,1000,1000);
  frame->setBackgroundColor("white");
  closeb = new QPushButton(mainframe, "Close");
  refreshb = new QPushButton(mainframe, "Refresh");
  closeb->setText("Close");
  refreshb->setText("Refresh");
  closeb->setGeometry(2,2,45,25);
  refreshb->setGeometry(50, 2, 55, 25);
  hscroll = new QScrollBar(0, 1000, 20, 100, 1000, QScrollBar::Horizontal, mainframe, "hscrollbar");
  hscroll->setGeometry(110,8,400,16);
  vscroll = new QScrollBar(0, 1000, 20, 100, 1000, QScrollBar::Vertical, mainframe, "vscrollbar");
  vscroll->setGeometry(1, 30, 16, 418);

  connect(hscroll, SIGNAL(nextLine()), SLOT(hSetNextLine()));
  connect(hscroll, SIGNAL(prevLine()), SLOT(hSetPrevLine()));
  connect(hscroll, SIGNAL(nextPage()), SLOT(hSetNextPage()));
  connect(hscroll, SIGNAL(prevPage()), SLOT(hSetPrevPage()));
  connect(hscroll, SIGNAL(sliderMoved(int)), SLOT(hSetMoved(int)));

  connect(vscroll, SIGNAL(nextLine()), SLOT(vSetNextLine()));
  connect(vscroll, SIGNAL(prevLine()), SLOT(vSetPrevLine()));
  connect(vscroll, SIGNAL(nextPage()), SLOT(vSetNextPage()));
  connect(vscroll, SIGNAL(prevPage()), SLOT(vSetPrevPage()));
  connect(vscroll, SIGNAL(sliderMoved(int)), SLOT(vSetMoved(int)));


  connect(closeb,SIGNAL(pressed()),SLOT(closeButton()));
  connect(refreshb, SIGNAL(pressed()), SLOT(refreshButton()));

  updateTreePic(treetab, frame, 5, ty);
  frame->show();
  mainframe->show();
}

void ShowTree::refreshButton()
{
  wx = mainframe->x();
  wy = mainframe->y();
  QFrame *old = mainframe;
  displayTree(FALSE);
  old->close();
}

void ShowTree::closeButton()
{
  mainframe->close();
}

void ShowTree::oneClick(QWidget *w)
{
  MyTree *temptree;
  QLabel *l;
  l = (QLabel*) w;
  QString name(l->text());
  temptree = treetab->findFeature1(treetab, 1, &name.copy());
  if (temptree->GetFeature2(14) == 0)
    temptree->SetFeature2(14, 1);
  else 
    temptree->SetFeature2(14, 0);
  refreshButton();
}

void ShowTree::hSetMoved(int val)
{
  if (val > lastx)
    {
      frame->scroll(val-lastx, 0);
      lastx = val;
    }
  else 
    {
      frame->scroll((lastx-val)*(-1), 0);
      lastx = val;
    }
}

void ShowTree::hSetNextLine()
{
  if (lastx <= 980) 
    {
      frame->scroll(20, 0);
      lastx += 20;
    }
  else 
    {
      frame->scroll(1000-lastx, 0);
      lastx = 1000;
    }
  
}

void ShowTree::hSetPrevLine()
{
  if (lastx >= 20) 
    {
      frame->scroll(-20, 0);
      lastx -= 20;
    }
  else
    {
      frame->scroll(-lastx, 0);
      lastx = 0;
    }
}

void ShowTree::hSetNextPage()
{
  if (lastx <= 900) 
    {
      frame->scroll(100,0);
      lastx += 100;
    }
}

void ShowTree::hSetPrevPage()
{
  if (lastx >= 100) 
    {
      frame->scroll(-100, 0);
      lastx -= 100;
    }
}

void ShowTree::vSetNextLine()
{
  if (lasty <= 980) 
    {
      frame->scroll(0, 20);
      lasty += 20;
    }
  else 
    {
      frame->scroll(0, 1000-lasty);
      lasty = 1000;
    }
}

void ShowTree::vSetPrevLine()
{
  if (lasty >= 20) 
    {
      frame->scroll(0, -20);
      lasty -= 20;
    }
  else
    {
      frame->scroll(0, -lasty);
      lasty = 0;
    }
}

void ShowTree::vSetNextPage()
{
  if (lasty <= 900) 
    {
      frame->scroll(0,100);
      lasty += 100;
    }
}

void ShowTree::vSetPrevPage()
{
  if (lasty >= 100) 
    {
      frame->scroll(0, -100);
      lasty -= 100;
    }
}

void ShowTree::vSetMoved(int val)
{
  if (val > lasty)
    {
      frame->scroll(0, val-lasty);
      lasty = val;
    }
  else 
    {
      frame->scroll(0, (lasty-val)*(-1));
      lasty = val;
    }
}
